package
{
	import com.greensock.TweenLite;
	import com.greensock.TweenMax;
	import com.greensock.plugins.HexColorsPlugin;
	import com.greensock.plugins.TweenPlugin;
	
	import flash.display.Shader;
	import flash.filters.ShaderFilter;
	
	import org.flixel.*;
	import org.flixel.system.FlxList;

	public class GameState extends FlxState
	{			
		
		[Embed(source="data/player.png")]
		public static var ImgPlayer:Class;
		[Embed(source="data/tiles.png")]
		public static var ImgTiles:Class;
		[Embed(source="data/rock.png")]
		public static var ImgRock:Class;
		
		
		[Embed(source="data/shack.png")]
		public static var ImgShack:Class;
		
		[Embed(source="data/cursor.png")]
		public static var ImgCursor:Class;

	
		private var mapsprites:FlxGroup;
		
		
		private var game:Game;
		
		public var undos:Vector.<Game>;
		
		private var gamegrp:FlxGroup;
		
		public var mouseover:FlxSprite;
		
		override public function create():void
		{	
			
			FlxG.bgColor=FlxG.WHITE;
			
			super.create();
			mouseover = new FlxSprite(-100,-100,ImgCursor);
			add(mouseover);
			mouseover.visible=false;
			
			gamegrp  = new FlxGroup();
			add(gamegrp);
			
			undos = new Vector.<Game>();
			
			if (FlxG.level>=0 && FlxG.level+1<10)
			{
				var movecount:int = FlxG.level+1;
				if (FlxG.level>5)
					movecount+=FlxG.level-5;
				
				game = Game.Generate(10,10,FlxG.level+1,movecount);
				updateVisuals();
				/*
				if (this.hasOwnProperty("TxtLevel"+FlxG.level))
				{
					var c:Class = this["TxtLevel"+FlxG.level];
					game = new Game(new c());
					updateVisuals();
				}*/
			}
			else
			{
				game = Game.Generate(10,10,9,100);
				updateVisuals();
			}
		}
		
		public function updateVisuals():void
		{			
			if (mapsprites!=null)
			{
				gamegrp.remove(mapsprites,true);
			}
			
			mapsprites = new FlxGroup();
			gamegrp.add(mapsprites);
			for each (var s:FlxSprite in game.GenSprites())
			{
				mapsprites.add(s);
			}	
		}
		
		private var won:Boolean=false;
		private var fading:Boolean=false;
		
		private function FadeComplete():void
		{			
			FlxG.level++;
			
			
			if (FlxG.level+1>=11)
			{				
				FlxG.switchState(new TitleState());
				return;
			}
			else
			{								
				var save:FlxSave = new FlxSave();			
				if (save.bind("StressGame"))
				{
					save.data.level=FlxG.level;
				}
			}
			
			
			FlxG.switchState(new GameState());
			return;
			
			CutSceneState.cutscene=FlxG.level;
			FlxG.switchState(new CutSceneState());
		}
		
		override public function update():void
		{
			var mx:int = FlxG.mouse.x/Game.tilesize;
			var my:int = FlxG.mouse.y/Game.tilesize;
			if (mx>=0 && mx <game.grid[0].length && my>=0 && my<game.grid.length)
			{
				mouseover.x=(mx-2)*10;
				mouseover.y=(my-2)*10;
				mouseover.visible=true;
				
			}
			else
			{
				mouseover.visible=false;
			}
			/*
			if (FlxG.keys.justPressed("O"))
			{
				FlxG.level--;
				FlxG.switchState(new GameState());
				super.update();
				return;
			}
			if (FlxG.keys.justPressed("P"))
			{
				FlxG.level++;
				
				var save:FlxSave = new FlxSave();			
				if (save.bind("MG"))
				{
					save.data.level=FlxG.level;					
				}
				
				FlxG.switchState(new GameState());
				super.update();
				return;
			}*/			
			
			var modified:Boolean=false;
			var last:Game;
			if (TweenMax.getAllTweens().length>0)
			{
				
			}	
			else if (fading)
			{
				
			}
			else if (won)
			{				
				fading=true;
				var s:FlxSound = FlxG.play(TitleState.SndLevelWin);
				s.survive=true;
				FlxG.fade(0xff000000,0.5,FadeComplete,true);
			}		
			/*else if (FlxG.keys.justPressed("R"))
			{
				FlxG.switchState(new GameState());
			}*/		
			
			else if (FlxG.keys.justPressed("Z"))
			{
				if (undos.length>0)
				{
					game=undos.pop();
					updateVisuals();
				}
			}
			else if (FlxG.mouse.justPressed())
			{
				game.ClearMoved();
				last=game.Copy();
				var mx:int = FlxG.mouse.x/Game.tilesize;
				var my:int = FlxG.mouse.y/Game.tilesize;
				modified = game.TryMove(mx,my);
				won = game.CheckWin();
			}
			/*
			else if (FlxG.keys.UP)
			{				
				game.ClearMoved();				
				last = game.Copy();
				modified = game.TryMove(game.player, FlxObject.UP);
				won=game.ProcessMoves();
			}
			else if (FlxG.keys.DOWN)
			{
				game.ClearMoved();
				last = game.Copy();
				modified = game.TryMove(game.player, FlxObject.DOWN);
				won=game.ProcessMoves();	
			}
			else if (FlxG.keys.LEFT)
			{
				game.ClearMoved();
				last = game.Copy();
				modified = game.TryMove(game.player, FlxObject.LEFT);
				won=game.ProcessMoves();
			}
			else if (FlxG.keys.RIGHT)
			{
				game.ClearMoved();
				last = game.Copy();
				modified = game.TryMove(game.player, FlxObject.RIGHT);
				won=game.ProcessMoves();
			}*/
			
			if (modified)
			{
				undos.push(last);
				
				updateVisuals();						
			}
			/*
			if (game.progress>oldprogress)
			{
				FlxG.play(SndPingLow);
			}*/
			super.update();
		}		
	}
}