package
{
	import com.greensock.TweenLite;
	import com.greensock.TweenMax;
	import com.greensock.plugins.HexColorsPlugin;
	import com.greensock.plugins.TweenPlugin;
	
	import flash.net.SharedObject;
	
	import flashx.textLayout.operations.CutOperation;
	
	import org.flixel.*;
	
	public class TitleState extends FlxState
	{				
		
		[Embed(source="data/mouseover.wav.mp3")]
		public static var SndMouseOver:Class;		
		[Embed(source="data/mouseoff.wav.mp3")]
		public static var SndMouseOff:Class;
		[Embed(source="data/click.wav.mp3")]
		public static var SndClick:Class;
		[Embed(source="data/compress.wav.mp3")]
		public static var SndCompress:Class;
		[Embed(source="data/cantcompress.wav.mp3")]
		public static var SndCantCompress:Class;
		[Embed(source="data/levelwin.wav.mp3")]
		public static var SndLevelWin:Class;
		
		[Embed(source="data/title.png")]
		public static var ImgBG:Class;
		
		[Embed(source="data/newgame.png")]
		public static var ImgNewGame:Class;
		[Embed(source="data/continue.png")]
		public static var ImgContinue:Class;
		
		[Embed(source="data/music.mp3")]
		public static var SndMusic:Class;
		
		override public function create():void
		{
			super.create();
			FlxG.playMusic(SndMusic,1.0);
			
			FlxG.level=0;
			var save:FlxSave = new FlxSave();			
			if (save.bind("StressGame"))
			{
				FlxG.level =  save.data.level;				
			}
			if (FlxG.level>=8)
				FlxG.level=0;
			
			this.add(new FlxSprite(0,0,ImgBG));
			
			var b:FlxButton;
			
			b = new FlxButton(10,60,"",ClickNew,ButtonOver,ButtonOff);
			b.loadGraphic(ImgNewGame);		
			
			add(b);
			
			
			b = new FlxButton(10,80,"",ClickContinue,ButtonOver,ButtonOff);
			b.loadGraphic(ImgContinue);
			
			if (FlxG.level==0)
			{
				b.active=false;
				b.alpha=0.3;
			}
			
			add(b);
		}
		
		public static var sfxvol:Number=0.5;
		private function ButtonOver():void
		{
			FlxG.play(TitleState.SndMouseOver,TitleState.sfxvol);
		}
		
		private function ButtonOff():void
		{
			FlxG.play(TitleState.SndMouseOff,TitleState.sfxvol);
		}
		
		override public function update():void
		{
			if (fading==false)
			{
				if (FlxG.keys.justPressed("SPACE"))
					ClickNew();
			}
			
			super.update();
		}		
		
		private var fading:Boolean=false;
		
		private function ClickNew():void
		{
			if (fading)
				return;
			
			FlxG.level=0;
			var save:FlxSave = new FlxSave();			
			if (save.bind("StressGame"))
			{
				save.data.level=FlxG.level;
			}
			fading=true;
			FlxG.play(TitleState.SndClick,TitleState.sfxvol);
			FlxG.fade(0xff000000,0.5,ClickNewFaded,true);
			
		}
		private function ClickNewFaded():void
		{
			FlxG.switchState(new GameState());			
		}
		
		private function ClickContinue():void
		{
			FlxG.play(TitleState.SndClick,TitleState.sfxvol);
			FlxG.fade(0xff000000,0.5,ClickContinueFaded,true);
			
		}
		private function ClickContinueFaded():void
		{
			FlxG.switchState(new GameState());			
		}
	}
}